VERSION 5.00
Begin VB.Form SelectForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Select Image"
   ClientHeight    =   3300
   ClientLeft      =   1650
   ClientTop       =   1935
   ClientWidth     =   7650
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3300
   ScaleWidth      =   7650
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox HiddenPict 
      AutoSize        =   -1  'True
      Height          =   495
      Left            =   960
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   6
      Top             =   2760
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.PictureBox ThumbPict 
      AutoRedraw      =   -1  'True
      Height          =   3255
      Left            =   2520
      ScaleHeight     =   3195
      ScaleWidth      =   4635
      TabIndex        =   5
      Top             =   0
      Width           =   4695
   End
   Begin VB.VScrollBar ThumbScroll 
      Height          =   3255
      Left            =   7320
      TabIndex        =   4
      Top             =   0
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.CommandButton CmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   495
      Left            =   1560
      TabIndex        =   3
      Top             =   2760
      Width           =   855
   End
   Begin VB.CommandButton CmdOpen 
      Caption         =   "Open"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   0
      TabIndex        =   2
      Top             =   2760
      Width           =   855
   End
   Begin VB.DirListBox DirList 
      Height          =   2340
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2415
   End
   Begin VB.DriveListBox DriveList 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2415
   End
End
Attribute VB_Name = "SelectForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Canceled As Boolean

' The ImageSelector that started us.
Dim TheSelector As ImageSelector

' The list of files in this directory.
Dim FileNames() As String
Dim NumFiles As Integer
Dim RowsVisible As Integer
Dim ColsVisible As Integer
Dim TotalRows As Integer

Const THUMB_WID = 1440
Const THUMB_HGT = 1440
Const THUMB_GAP = 120
Const THUMB_ASPECT = (THUMB_HGT / THUMB_WID)

' The index of the selected picture (0 if none).
Dim ThumbSelected As Integer
Dim SelectedX As Single
Dim SelectedY As Single

' Coordinates clicked.
Dim ClickX As Single
Dim ClickY As Single

Dim skip_drawing As Boolean
' *********************************************
' Return the currently selected path.
' *********************************************
Public Property Get Path() As String
Dim file_path As String

    file_path = DirList.Path
    If Right$(file_path, 1) <> "\" Then _
        file_path = file_path & "\"
    
    Path = file_path
End Property

' *********************************************
' Select a thumbnail.
' *********************************************
Private Sub SelectThumb(X As Single, Y As Single)
Dim r As Single
Dim c As Single
Dim i As Integer

    ' Deselect any previously selected thumbnail.
    If ThumbSelected > 0 Then
        ThumbPict.DrawMode = vbInvert
        ThumbPict.DrawWidth = 3
        ThumbPict.Line (SelectedX, SelectedY)-Step(THUMB_WID, THUMB_HGT), , B
        ThumbPict.DrawMode = vbCopyPen
        ThumbPict.DrawWidth = 1
        ThumbSelected = 0
        CmdOpen.Enabled = False
    End If
    
    c = Int((X - THUMB_GAP) / (THUMB_WID + THUMB_GAP)) + 1
    If c < 1 Or c > ColsVisible Then Exit Sub
    ' See if the click is between columns.
    If X > c * (THUMB_WID + THUMB_GAP) Then Exit Sub
    
    r = Int((Y - THUMB_GAP) / (THUMB_HGT + THUMB_GAP)) + 1
    If r < 1 Or r > RowsVisible Then Exit Sub
    ' See if the click is between rows.
    If Y > r * (THUMB_HGT + THUMB_GAP) Then Exit Sub
    
    ' See which picture it is.
    i = (ThumbScroll.Value + (r - 1)) * _
        ColsVisible + (c - 1) + 1
    If i > NumFiles Then Exit Sub
    
    ' Select the new thumbnail.
    ThumbPict.DrawMode = vbInvert
    ThumbPict.DrawWidth = 3
    SelectedX = (c - 1) * (THUMB_WID + THUMB_GAP) + THUMB_GAP
    SelectedY = (r - 1) * (THUMB_HGT + THUMB_GAP) + THUMB_GAP
    ThumbPict.Line (SelectedX, SelectedY)-Step(THUMB_WID, THUMB_HGT), , B
    ThumbPict.DrawMode = vbCopyPen
    ThumbPict.DrawWidth = 1
    ThumbSelected = i
    Caption = TheSelector.DialogTitle & _
        ": " & FileName
    CmdOpen.Enabled = True
End Sub
' *********************************************
' Return the currently selected file name.
' *********************************************
Public Property Get FileName() As String
    If Canceled Then
        FileName = ""
    Else
        FileName = FileNames(ThumbSelected)
    End If
End Property
' *********************************************
' Return the currently selected disk drive.
' *********************************************
Public Property Get Drive() As String
    Drive = DriveList.Drive
End Property
' *********************************************
' Display a thumbnail for the indicated file
' at the specified location.
' *********************************************
Private Sub ShowThumb(ByVal X As Single, ByVal Y As Single, file_path As String, file_name As String)
Dim aspect As Single
Dim x1 As Single
Dim y1 As Single
Dim wid1 As Single
Dim hgt1 As Single

    On Error GoTo LoadPictureError
    HiddenPict.Picture = _
        LoadPicture(file_path & file_name)
    On Error GoTo 0
    
    ' Give the thumbnail the same aspect ratio
    ' as the original picture.
    aspect = HiddenPict.ScaleHeight / _
             HiddenPict.ScaleWidth
    If aspect > THUMB_ASPECT Then
        ' The picture is relatively tall and
        ' thin compared to the thumbnail area.
        hgt1 = THUMB_HGT
        wid1 = hgt1 / aspect
        x1 = (THUMB_WID - wid1) / 2
        y1 = 0
    Else
        ' The picture is relatively short and
        ' wide compared to the thumbnail area.
        wid1 = THUMB_WID
        hgt1 = aspect * wid1
        x1 = 0
        y1 = (THUMB_HGT - hgt1) / 2
    End If
    
    ' Copy the picture.
    ThumbPict.PaintPicture HiddenPict, _
        X + x1, Y + y1, wid1, hgt1
    
    ' Draw a box around it.
    ThumbPict.Line (X, Y)-Step(THUMB_WID, THUMB_HGT), , B
    Exit Sub

LoadPictureError:
    ThumbPict.CurrentX = X + (THUMB_WID - TextWidth(file_name)) / 2
    ThumbPict.CurrentY = Y + (THUMB_HGT - TextHeight(file_name)) / 2
    ThumbPict.Print file_name
    ThumbPict.Line (X, Y)-Step(THUMB_WID, THUMB_HGT), , B
    ThumbPict.Line (X, Y)-Step(THUMB_WID, THUMB_HGT)
    ThumbPict.Line (X + THUMB_WID, Y)-Step(-THUMB_WID, THUMB_HGT)
End Sub
' *********************************************
' Display the thumbnails.
' *********************************************
Private Sub ShowThumbnails()
Dim file_path As String
Dim cols_visible As Integer
Dim rows_visible As Integer
Dim i As Integer
Dim r As Integer
Dim c As Integer
Dim X As Single
Dim Y As Single

    ' Start from scratch.
    ThumbPict.Cls

    ' If there are no files, do nothing more.
    If NumFiles < 1 Then Exit Sub
    
    ' No thumbnail is currently selected.
    ThumbSelected = 0
    CmdOpen.Enabled = False

    ' Find the directory path.
    file_path = DirList.Path
    If Right$(file_path, 1) <> "\" Then _
        file_path = file_path & "\"
    
    MousePointer = vbHourglass
    DoEvents
    
    ' ThumbScroll.Value indicates the number of
    ' rows that have scrolled up beyond
    ' visibility. Calculate the index of the
    ' first visible file.
    i = ThumbScroll.Value * ColsVisible + 1
    For r = 1 To RowsVisible
        For c = 1 To ColsVisible
            X = THUMB_GAP + (c - 1) * (THUMB_WID + THUMB_GAP)
            Y = THUMB_GAP + (r - 1) * (THUMB_HGT + THUMB_GAP)
            ShowThumb X, Y, file_path, FileNames(i)
            
            ' Give buttons a chance to catch up.
            ThumbPict.Refresh
            i = i + 1
            If i > NumFiles Then Exit For
        Next c
        If i > NumFiles Then Exit For
    Next r

    MousePointer = vbDefault
End Sub
' *********************************************
' Build the list of files.
' *********************************************
Private Sub MakeFileList()
Dim types As New Collection
Dim file_type As Variant
Dim path_name As String
Dim file_name As String
Dim i As Integer

    ' Start with no file selected.
    ThumbSelected = 0
    Caption = TheSelector.DialogTitle
    CmdOpen.Enabled = False
    
    ' List the file types we want to view.
    types.Add "*.bmp"   ' Bitmap
    types.Add "*.gif"   ' GIF
    types.Add "*.ico"   ' Icon
    types.Add "*.rle"   ' Run-length encoded
    types.Add "*.wmf"   ' Windows metafile (some)
    types.Add "*.emf"   ' Enhanced metafile
'   JPG files are slow so commented out.
'   types.Add "*.jpg"   ' JPEG

    ' Count the files.
    NumFiles = 0
    For Each file_type In types
        path_name = DirList.Path
        If Right$(path_name, 1) <> "\" Then path_name = path_name & "\"
        path_name = path_name & file_type

        file_name = Dir(path_name)
        Do While file_name <> ""
            NumFiles = NumFiles + 1
            file_name = Dir
        Loop
    Next file_type
    
    ' Make a list of the files.
    ReDim FileNames(0 To NumFiles)
    i = 1
    For Each file_type In types
        path_name = DirList.Path
        If Right$(path_name, 1) <> "\" Then path_name = path_name & "\"
        path_name = path_name & file_type

        file_name = Dir(path_name)
        Do While file_name <> ""
            FileNames(i) = file_name
            i = i + 1
            file_name = Dir
        Loop
    Next file_type
    
    ' Sort the file names.
    Quicksort FileNames(), 1, NumFiles

    ' Reset the total number of rows needed.
    SetTotalRows

    ' Display the list.
    ThumbScroll.Value = 0
    
    ' If we're not loading, display the files.
    If Not skip_drawing Then ShowThumbnails
End Sub
' *********************************************
' Recursively sort the list using quicksort.
' *********************************************
Private Sub Quicksort(List() As String, min As Integer, max As Integer)
Dim med_value As String
Dim hi As Integer
Dim lo As Integer
Dim i As Integer

    ' If the list has <= 1 element, it's sorted.
    If min >= max Then Exit Sub

    ' Pick a dividing item.
    i = Int((max - min + 1) * Rnd + min)
    med_value = List(i)

    ' Swap it to the front.
    List(i) = List(min)

    ' Move smaller items to the left half of
    ' the list. Move the others into the right.
    lo = min
    hi = max
    Do
        ' Look down from hi for a value < med_value.
        Do While List(hi) >= med_value
            hi = hi - 1
            If hi <= lo Then Exit Do
        Loop
        If hi <= lo Then
            List(lo) = med_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        List(lo) = List(hi)
        
        ' Look up from lo for a value >= med_value.
        lo = lo + 1
        Do While List(lo) < med_value
            lo = lo + 1
            If lo >= hi Then Exit Do
        Loop
        If lo >= hi Then
            lo = hi
            List(hi) = med_value
            Exit Do
        End If
        
        ' Swap the lo and hi values.
        List(hi) = List(lo)
    Loop
    
    ' Recursively sort the two sublists
    Quicksort List(), min, lo - 1
    Quicksort List(), lo + 1, max
End Sub
' *********************************************
' Allow the user to select a file.
' *********************************************
Public Sub ShowSelect(sel As ImageSelector)
Dim ctl As Control

    Set TheSelector = sel
    
    ' Copy properties into our controls.
    On Error Resume Next
    For Each ctl In Controls
        ctl.BackColor = sel.BackColor
        ctl.ForeColor = sel.ForeColor
        Set ctl.Font = sel.Font
    Next ctl
    Caption = TheSelector.DialogTitle
    On Error GoTo 0
    
    ' We have not yet canceled.
    Canceled = False
    
    ' Show the dialog.
    Me.Show vbModal
End Sub
' *********************************************
' The user wants to cancel the operation.
' *********************************************
Private Sub CmdCancel_Click()
    Canceled = True
    
    ' Hide the form.
    Me.Hide
End Sub
' *********************************************
' The user wants to open the selected file.
' *********************************************
Private Sub CmdOpen_Click()
    ' Hide the form.
    Me.Hide
End Sub


' *********************************************
' The user has selected a new drive.
' Make the directory list use the new drive.
' *********************************************
Private Sub DriveList_Change()
    On Error GoTo DriveError
    DirList.Path = Left$(DriveList.Drive, 2) & "\"
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub

' *********************************************
' The user has selected a new directory. Make a
' list of the files in the directory.
' *********************************************
Private Sub DirList_Change()
    MakeFileList
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Canceled = True
    
    ' Hide the form instead of unloading it.
    Cancel = (UnloadMode = vbFormControlMenu)
    Me.Hide
End Sub
Private Sub Form_Resize()
Const GAP = 60

Dim hgt As Single
Dim wid As Single
Dim min_wid As Single

    hgt = ScaleHeight - DirList.Top - CmdOpen.Height - GAP
    If hgt < 240 Then hgt = 240
    DirList.Height = hgt
    
    CmdOpen.Top = DirList.Top + DirList.Height + GAP
    CmdCancel.Top = CmdOpen.Top
    
    ' Make sure there's room for at least one
    ' column of thumbnails.
    wid = ScaleWidth - (CmdCancel.Left + CmdCancel.Width) - GAP - ThumbScroll.Width
    min_wid = THUMB_WID + 2 * THUMB_GAP + _
        ThumbPict.Width - ThumbPict.ScaleWidth
    If wid < min_wid Then wid = min_wid
    
    ThumbPict.Move CmdCancel.Left + CmdCancel.Width + GAP, _
        0, wid, ScaleHeight
    ThumbScroll.Move ThumbPict.Left + ThumbPict.Width, _
        0, ThumbScroll.Width, ScaleHeight
End Sub

' *********************************************
' Select a thumbnail.
' *********************************************
Private Sub ThumbPict_Click()
    SelectThumb ClickX, ClickY
End Sub

' *********************************************
' If a thumbnail is currently selected, trigger
' the Open button.
' *********************************************
Private Sub ThumbPict_DblClick()
    If ThumbSelected > 0 Then CmdOpen_Click
End Sub

' *********************************************
' Record the coordinates so the Click event
' can select a thumbnail.
' *********************************************
Private Sub ThumbPict_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ClickX = X
    ClickY = Y
End Sub

' *********************************************
' See how many thumbnails will now fit and
' redisplay the thumbnails if necessary.
' *********************************************
Private Sub ThumbPict_Resize()
Static done_before As Boolean

Dim cols_visible As Integer
Dim rows_visible As Integer

    ' See how many rows and columns will fit.
    cols_visible = _
        (ThumbPict.ScaleWidth - THUMB_GAP) \ _
        (THUMB_WID + THUMB_GAP)
    If cols_visible < 1 Then cols_visible = 1
    rows_visible = _
        (ThumbPict.Height - THUMB_GAP) \ _
        (THUMB_HGT + THUMB_GAP)
    If rows_visible < 1 Then rows_visible = 1
    
    ' Do nothing if the number of visible rows
    ' and columns has not changed.
    If ColsVisible = cols_visible And _
       RowsVisible = rows_visible Then _
            Exit Sub
    
    ' Update the numbers.
    ColsVisible = cols_visible
    RowsVisible = rows_visible
    
    ' Set the scroll bar's LargeChange property.
    ThumbScroll.LargeChange = RowsVisible
    
    ' Calculate the total number of rows.
    SetTotalRows
    
    If Not done_before Then
        ' If it's the first time, load the
        ' drive and path.
        done_before = True
        skip_drawing = True
        On Error Resume Next
        DriveList.Drive = TheSelector.Drive
        DirList.Path = TheSelector.Path
        skip_drawing = False
    End If
    
    ' Display the thumbnails.
    ShowThumbnails
End Sub
' *********************************************
' Calculate the total number of rows needed.
' *********************************************
Private Sub SetTotalRows()
    TotalRows = NumFiles \ ColsVisible
    If TotalRows * ColsVisible < NumFiles Then _
        TotalRows = TotalRows + 1
        
    ' See if the scrollbar is needed.
    If TotalRows > RowsVisible Then
        ThumbScroll.min = 0
        ThumbScroll.max = TotalRows - RowsVisible
        ThumbScroll.Visible = True
    Else
        ThumbScroll.Visible = False
        ThumbScroll.Value = 0
    End If
End Sub

Private Sub ThumbScroll_Change()
    ShowThumbnails
End Sub


