VERSION 5.00
Begin VB.UserControl ThumbnailSelector 
   ClientHeight    =   375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   540
   InvisibleAtRuntime=   -1  'True
   Picture         =   "ThumbSel.ctx":0000
   ScaleHeight     =   375
   ScaleWidth      =   540
   ToolboxBitmap   =   "ThumbSel.ctx":07C6
End
Attribute VB_Name = "ThumbnailSelector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Thumbnail image selector dialog control"
Option Explicit

'Default Property Values:
Const m_def_Path = "\"
Const m_def_Drive = "C:"
Const m_def_DialogTitle = "Select File"
Const m_def_FileName = ""
'Property Variables:
Dim m_Path As String
Dim m_Drive As String
Dim m_DialogTitle As String
Dim m_FileName As String
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub

Public Property Get DialogTitle() As String
    DialogTitle = m_DialogTitle
End Property

Public Property Let DialogTitle(ByVal New_DialogTitle As String)
Attribute DialogTitle.VB_Description = "The title displayed by the dialog."
    m_DialogTitle = New_DialogTitle
    PropertyChanged "DialogTitle"
End Property

Public Property Get FileName() As String
Attribute FileName.VB_Description = "The name of the file selected."
    FileName = m_FileName
End Property

Public Property Let FileName(ByVal New_FileName As String)
    m_FileName = New_FileName
    PropertyChanged "FileName"
End Property

' *********************************************
' Allow the user to select an image file.
' *********************************************
Public Sub ShowSelect()
Attribute ShowSelect.VB_Description = "Allows the user to select a file."
Dim frm As New SelectForm

    ' Present the dialog.
    frm.ShowSelect Me
    
    ' Save the drive, path, and file.
    m_Drive = frm.Drive
    m_Path = frm.Path
    m_FileName = frm.FileName
    
    Unload frm
End Sub
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_DialogTitle = m_def_DialogTitle
    m_FileName = m_def_FileName
    Set Font = Ambient.Font
    m_Path = m_def_Path
    m_Drive = m_def_Drive
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_DialogTitle = PropBag.ReadProperty("DialogTitle", m_def_DialogTitle)
    m_FileName = PropBag.ReadProperty("FileName", m_def_FileName)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    m_Path = PropBag.ReadProperty("Path", m_def_Path)
    m_Drive = PropBag.ReadProperty("Drive", m_def_Drive)
End Sub
Private Sub UserControl_Resize()
Const FIXED_WID = 540
Const FIXED_HGT = 375

Static resizing As Boolean

    ' Do not recurse.
    If resizing Then Exit Sub
    
    resizing = True
    Size FIXED_WID, FIXED_HGT
    resizing = False
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("DialogTitle", m_DialogTitle, m_def_DialogTitle)
    Call PropBag.WriteProperty("FileName", m_FileName, m_def_FileName)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Path", m_Path, m_def_Path)
    Call PropBag.WriteProperty("Drive", m_Drive, m_def_Drive)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property
'
'Public Property Get Path() As String
'    Path = m_Path
'End Property
'
'Public Property Let Path(ByVal New_Path As String)
'    m_Path = New_Path
'    PropertyChanged "Path"
'End Property
'
Public Property Get Path() As String
Attribute Path.VB_Description = "The currently selected directory path."
    Path = m_Path
End Property

Public Property Let Path(ByVal New_Path As String)
    m_Path = New_Path
    PropertyChanged "Path"
End Property

Public Property Get Drive() As String
Attribute Drive.VB_Description = "The currently selected disk drive."
    Drive = m_Drive
End Property

Public Property Let Drive(ByVal New_Drive As String)
    m_Drive = New_Drive
    PropertyChanged "Drive"
End Property

